<template>
  <v-layout>
    <v-flex>
      <CreateTask></CreateTask>
      <h2>Публичные жалобы</h2>
      <br>
      <v-flex sm3>
        <v-select
          :items="statuses"
          label="Статус жалобы"
          item-text="name"
          item-value="alias"
          prefix
          v-model="filters.status"
        ></v-select>
      </v-flex>
      <v-layout class="full-height" column>
        <v-data-iterator
          :items="tasks"
          no-data-text="Нет доступных жалоб"
          content-class="justify-start row wrap fill-height"
          content-tag="v-layout"
          hide-actions
          row
        >
          <template v-slot:item="props">
            <v-flex class="mx-2 mb-3 d-flex" md3 xs12>
              <v-card>
                <router-link
                  :to="{ name: 'maps', params: { id: props.item.id, link: 'task-detail' }}"
                >
                  <v-card-title>
                    <h4>{{ props.item.name }}</h4>
                  </v-card-title>
                </router-link>
                <v-divider></v-divider>
                <v-list dense>
                  <v-list-tile>
                    <v-list-tile-content>Локация
                    </v-list-tile-content>
                    <v-list-tile-content class="align-end">
                      Ул. Ростовская 22
                    </v-list-tile-content>
                  </v-list-tile>
                  <v-list-tile>
                    <v-list-tile-content>Тип жалобы
                    </v-list-tile-content>
                    <v-list-tile-content class="align-end">
                      {{ props.item.type.name }}
                    </v-list-tile-content>
                  </v-list-tile>
                  <v-list-tile>
                    <v-list-tile-content>Голосов
                    </v-list-tile-content>
                    <v-list-tile-content class="align-end">
                      {{props.item.followerList.length}}
                    </v-list-tile-content>
                  </v-list-tile>
                </v-list>
                <p class="text-xs-center">Описание:</p>
                <div class="mx-3">
                  {{props.item.description}}Описание:
                </div>
                <br>
              </v-card>
            </v-flex>
          </template>
        </v-data-iterator>
        <BaseButton text="Показать ещё"></BaseButton>
      </v-layout>
    </v-flex>
  </v-layout>
</template>

<script>
  import CreateTask from '@/views/tasks/CreateTask'
  import BaseButton from '@/components/base/Button'
  import { TaskModel } from '@/models/TaskModel'
  import { mapActions } from 'vuex'
  import { paginationFunctions } from '@/utils/paginationFunctions'

  /**
   * @name Tasks
   * @mixes Vue
   */
  export default {
    name: 'Tasks',
    components: { BaseButton, CreateTask },
    data () {
      return {
        statuses: TaskModel.getStatuses(),
        filters: TaskModel.getFilters()
      }
    },
    computed: {
      tasks () {
        return this.$store.getters.tasks;
      }
    },
    methods: {
      ...mapActions([
        'getTasks',
        'getPublicTasks'
      ]),
      getMoreTasks () {
        this.filters.limit += 1;
      }
    },
    watch: {
      filters: {
        handler (filters) {
          const pagination = paginationFunctions(filters.page, filters.limit);
          this.getPublicTasks(Object.assign(filters, pagination));
        },
        deep: true
      }
    },
    async mounted () {
      this.$store.commit('cleanTasks');
      await this.getPublicTasks(this.filters);
    }
  }
</script>
